/* Somaplayer - Copyright (C) 2003-5 bakunin - Andrea Marchesini 
 *                                     <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This program is released under the GPL with the additional exemption that
 * compiling, linking, and/or using OpenSSL is allowed.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include "player.h"
#include "fsignal.h"
#include "other.h"

#ifdef ENABLE_GTK
#include "gtk/graphic.h"
#endif

/* SIGINT */
void
signal_handler (int signo)
{

#ifdef ENABLE_GTK
  if (play->graphic)
    gtk_main_quit ();
#endif

  events.quit = 1;
}

/* SegFault */
void
segfault_handler (int signo)
{

  fprintf (stderr,
	   "\nSegmentation fault\n\n %s",
	   _
	   ("You've probably found a bug in SomaPlayer.\nSend an email to: soma@inventati.org. Thanks!\n\n"));
  quit (1);
}

/* EOF */
